import { world, system, EntityInventoryComponent } from "@minecraft/server";
import { ShovelBreak } from "./impl/exports";
import { getItemsWithTag } from "./functions";

world.beforeEvents.playerBreakBlock.subscribe(event => {
  const { player, block, itemStack } = event;

  if (player.isSneaking) return;
  ShovelBreak.execute(itemStack, player, block);
});

system.runInterval(() => {
  for (const player of world.getPlayers()) {
    getItemsWithTag(player, "minecraft:is_shovel").forEach(item => {
      const playerInventoryComponentContainer = player.getComponent(EntityInventoryComponent.componentId).container;
      
      item.item.setLore([ "§r§4 Excavator" ]);
      playerInventoryComponentContainer.setItem(item.slot, item.item);
    });
  }
}, 0);

system.beforeEvents.watchdogTerminate.subscribe(event => event.cancel = true);